const  asistentesNoMusicosModelo  = require('../models/asistentesNoMusicos');
const  sesiongrabacionModelo  = require('../models/sesiongrabacion');
const  equipoestudioModelo  = require('../models/equipoestudio');
const emailMethods = require('../emails/emailsMethods')
const  percentagesModelo  = require('../models/percentages');
const  preceivedPaymentsModelo  = require('../models/receivedPayments');


const moment = require('moment');

  const updateNoMusico = async (req, res) =>{  
    let { nombre, telefono, funcion, id } = req.body;    
    await asistentesNoMusicosModelo.updateMusicoById(nombre, telefono, funcion, id);
    res.status(200).json({ result: true })
  }
  const updateEquipoEstudio = async (req, res) =>{  
    let { nombre, marca, commentarios , id } = req.body;        
    await equipoestudioModelo.updateEquipoEstudio(nombre, marca, commentarios , id);
    res.status(200).json({ result: true })
  }

  const editEleccionPost = async (req, res) => {
    let pendinToReviewEstatus_id = 2;
    let sesiongrabacion_id = req.params.id;
    let result = await sesiongrabacionModelo.updateCitaToStatus(sesiongrabacion_id,pendinToReviewEstatus_id)
    let sesiones = [];
    if(res.locals.roleId !== 1)
    {
      return res.redirect(`/cotizacionesMenu/${sesiongrabacion_id}`);
    }
    else
    {
      let msj = "¡Tu reservación se ha enviado con éxito! En breve, nuestros administradores se pondrán en contacto contigo para brindarte una cotización personalizada. ¡Gracias por elegir nuestros servicios!"

      let user_id = res.locals.userId;
      await sesiongrabacionModelo.deleteEmptySesions(user_id)
      sesiones = await sesiongrabacionModelo.getAllSesionsgrabacionByUserId(user_id);
      await emailMethods.sendNewRequest('editSesionByManager', sesiongrabacion_id, ['josepabloosioavila@gmail.com'])
      return res.render('./menu.html', { sesiones, msj });    
    }   
  }

  const updatePercentageIndiv = async (req, res) =>{  
    let { id, percentage, justification } = req.body;      
    await percentagesModelo.updatePercentageById(id, percentage, justification);
    // await equipoestudioModelo.updateEquipoEstudio(nombre, marca, commentarios , id);
    res.status(200).json({ result: true })
  }


  const updateReceivedPaymentById = async (req, res) =>{  
    let { id, amount, comments } = req.body;      
    await preceivedPaymentsModelo.updateReceivedPaymentById(id, amount, comments);
    res.status(200).json({ result: true })
  }
  

module.exports = {
    updateNoMusico,
    updateEquipoEstudio,
    editEleccionPost, 
    updatePercentageIndiv,
    updateReceivedPaymentById
}