
const mysqlConnection = require('../config/database');


  createCita= async (data) => {

    return new Promise((resolve, reject) => {             
        mysqlConnection.query('INSERT INTO sesiongrabacion SET ?', data, function (error, results) {   
            if(!error){
               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
  }
 
  

  
  updatePriceCita= async (precioTotal,idsesiongrabacion) => {

    return new Promise((resolve, reject) => {      
        const updateQuery = 'UPDATE sesiongrabacion SET precioTotal = ? WHERE idsesiongrabacion = ?';       
        mysqlConnection.query(updateQuery, [precioTotal, idsesiongrabacion], (err, result) => {

            if(!err){
                
                resolve({
                    codigo: 0
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
  }

  confirmReserve= async (idsesiongrabacion) => {

    return new Promise((resolve, reject) => {

      
        const updateQuery = 'UPDATE sesiongrabacion SET estatus_id =2  WHERE idsesiongrabacion = '+idsesiongrabacion;
               
        mysqlConnection.query(updateQuery, (err, result) => {

            if(!err){
                
                resolve({
                    codigo: 0
                })
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
  }

  finalizarReserve= async (idsesiongrabacion) => {

    return new Promise((resolve, reject) => {      
        const updateQuery = 'UPDATE sesiongrabacion SET estatus_id =3  WHERE idsesiongrabacion = '+idsesiongrabacion;
               
        mysqlConnection.query(updateQuery, (err, result) => {

            if(!err){
                
                resolve({
                    codigo: 0
                })
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
  }


  reverseService= async (listService) => {
    return new Promise((resolve, reject) => {

            const query = 'INSERT INTO reverseservicios (servicio_id,sesiongrabacion_id) VALUES ?';
            const values = listService.map((availability) => [
                availability.servicio_id,
                availability.sesiongrabacion_id
            ]);

            mysqlConnection.query(query, [values], (error) => {
                if (error) {
                        console.error('Error inserting availability:', error);
                        reject(error)
                } else {
                    resolve({
                        codigo: 0
                    })
                }
            });
    })
  }


  reverseServiceAdditional= async (listServiceAdditional) => {


    return new Promise((resolve, reject) => {

            const query = 'INSERT INTO reverseserviciosadicionales (servicioadiconales_id,sesiongrabacion_id) VALUES ?';
            const values = listServiceAdditional.map((availability) => [
                availability.servicioadiconales_id,
                availability.sesiongrabacion_id
            ]);

            mysqlConnection.query(query, [values], (error) => {
                if (error) {
                        console.error('Error inserting availability:', error);
                        reject(error)
                } else {
                    console.log('Availability inserted successfully');
                    resolve({
                        codigo: 0
                    })
                }
            });
    })
  }

  validarReserve= (email,dias,horarios) => {

    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from sesiongrabacion where  email='" + email + "' and dias='"+dias+"' and horarios='"+horarios+"'";
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){
            
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

registrarAsistentesMusicos= async (listaAsistentesMusicos) => {


     
    return new Promise((resolve, reject) => {

        const query = 'INSERT INTO asistentesmusicos (nombre,telefono,email,instrumentos,sesiongrabacion_id) VALUES ?';
        const values = listaAsistentesMusicos.map((asistentesmusicos) => [
            asistentesmusicos.nombre,
            asistentesmusicos.telefono,
            asistentesmusicos.email,
            asistentesmusicos.instrumentos,
            asistentesmusicos.sesiongrabacion_id
        ]);

        mysqlConnection.query(query, [values], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                resolve({
                    codigo: 0
                })
            }
        });
    })
  }


  registrarAsistentesNoMusicos= async (listaAsistentesNoMusicos) => {



    return new Promise((resolve, reject) => {

        const query = 'INSERT INTO asistentesnomusicos (funcion,sesiongrabacion_id) VALUES ?';
        const values = listaAsistentesNoMusicos.map((asistentesNomusicos) => [
            asistentesNomusicos.funcion,
            asistentesNomusicos.sesiongrabacion_id
        ]);

        mysqlConnection.query(query, [values], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                resolve({
                    codigo: 0
                })
            }
        });
    })

  
  }

  
  registrarBitacora= async (listaBitacora) => {


    return new Promise((resolve, reject) => {

            const query = 'INSERT INTO bitacora (fecha,hora,informe,sesiongrabacion_id) VALUES ?';
            const values = listaBitacora.map((bitacora) => [
                bitacora.fecha,
                bitacora.hora,
                bitacora.informe,
                bitacora.sesiongrabacion_id
            ]);

            mysqlConnection.query(query, [values], (error) => {
                if (error) {
                        console.error('Error inserting availability:', error);
                        reject(error)
                } else {
                    resolve({
                        codigo: 0
                    })
                }
            });
    })
  }

  registrarEquipoEstudio= async (listaEquipo) => {



    return new Promise((resolve, reject) => {

        const query = 'INSERT INTO equipoestudio (nombre,marca,comentarios,sesiongrabacion_id) VALUES ?';
        const values = listaEquipo.map((bitacora) => [
            bitacora.nombre,
            bitacora.marca,
            bitacora.comentarios,
            bitacora.sesiongrabacion_id
        ]);

        mysqlConnection.query(query, [values], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                resolve({
                    codigo: 0
                })
            }
        });
      })
    
  }


  async function deleteRecordsFromTable(tableName, condition) {
   
    return new Promise((resolve, reject) => {
      const query = `DELETE FROM ${tableName} WHERE ${condition}`;
      console.log("query",query);
  
      mysqlConnection.query(query, (error, results) => {
        if (error) {
          reject(error);
        } else {
          resolve(results);
        }
      });
    });
  }



  async function deleteFromMultipleTables(sesiongrabacion_id) {

    return new Promise((resolve, reject) => {
    mysqlConnection.getConnection(function(err, connection) {
        connection.beginTransaction(async function(err) {
            if (err) {                  //Transaction Error (Rollback and release connection)
                connection.rollback(function() {
                    connection.release();
                    //Failure
                });
            } else {

                try {
   
                    await connection.beginTransaction();
                
                    // Eliminar registros en la tabla 1
                    await deleteRecordsFromTable('asistentesmusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 2
                    await deleteRecordsFromTable('asistentesnomusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 3
                    await deleteRecordsFromTable('reverseservicios', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    await deleteRecordsFromTable('reverseserviciosadicionales', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // ... Agregar más tablas si es necesario
                
                    await connection.commit();


                    resolve({
                        codigo: 0
                    })
                
                  } catch (error) {
                    await connection.rollback();
                    console.error('Error eliminando registros:', error);
                
                  } finally {
                    //db.end();
                  }

            }    
        });
    });
   });
  }

  async function deleteFromMultipleTablesAdmin(sesiongrabacion_id) {

    return new Promise((resolve, reject) => {
    mysqlConnection.getConnection(function(err, connection) {
        connection.beginTransaction(async function(err) {
            if (err) {                  //Transaction Error (Rollback and release connection)
                connection.rollback(function() {
                    connection.release();
                    //Failure
                });
            } else {

                try {
   
                    await connection.beginTransaction();
                
                    // Eliminar registros en la tabla 1
                    await deleteRecordsFromTable('asistentesmusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 2
                    await deleteRecordsFromTable('asistentesnomusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 3
                    await deleteRecordsFromTable('reverseservicios', 'sesiongrabacion_id='+sesiongrabacion_id);

                    await deleteRecordsFromTable('reverseserviciosadicionales', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                  //  await deleteRecordsFromTable('bitacora', 'sesiongrabacion_id='+sesiongrabacion_id);

                    //await deleteRecordsFromTable('equipoestudio', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // ... Agregar más tablas si es necesario
                
                    await connection.commit();

                    resolve({
                        codigo: 0
                    })
                
                  } catch (error) {
                    await connection.rollback();
                    console.error('Error eliminando registros:', error);
                
                  } finally {
                    //db.end();
                  }

            }    
        });
    });
   });
  }

  async function deleteFromMultipleTablesReserve(sesiongrabacion_id) {

    return new Promise((resolve, reject) => {
    mysqlConnection.getConnection(function(err, connection) {
        connection.beginTransaction(async function(err) {
            if (err) {                  //Transaction Error (Rollback and release connection)
                connection.rollback(function() {
                    connection.release();
                    //Failure
                });
            } else {

                try {
   
                    await connection.beginTransaction();
                
                    // Eliminar registros en la tabla 1
                    await deleteRecordsFromTable('asistentesmusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 2
                    await deleteRecordsFromTable('asistentesnomusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 3
                    await deleteRecordsFromTable('reverseservicios', 'sesiongrabacion_id='+sesiongrabacion_id);

                    await deleteRecordsFromTable('reverseserviciosadicionales', 'sesiongrabacion_id='+sesiongrabacion_id);
                    await deleteRecordsFromTable('sesiongrabacion', 'idsesiongrabacion='+sesiongrabacion_id);
                
                  //  await deleteRecordsFromTable('bitacora', 'sesiongrabacion_id='+sesiongrabacion_id);

                    //await deleteRecordsFromTable('equipoestudio', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // ... Agregar más tablas si es necesario
                
                    await connection.commit();

                    resolve({
                        codigo: 0
                    })
                
                  } catch (error) {
                    await connection.rollback();
                    console.error('Error eliminando registros:', error);
                
                  } finally {
                    //db.end();
                  }

            }    
        });
    });
   });
  }

  async function deleteFromMultipleTablesAdminBitacora(sesiongrabacion_id) {

    return new Promise((resolve, reject) => {
    mysqlConnection.getConnection(function(err, connection) {
        connection.beginTransaction(async function(err) {
            if (err) {                  //Transaction Error (Rollback and release connection)
                connection.rollback(function() {
                    connection.release();
                    //Failure
                });
            } else {

                try {
   
                    await connection.beginTransaction();
                
                    // Eliminar registros en la tabla 1
                    await deleteRecordsFromTable('asistentesmusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 2
                    await deleteRecordsFromTable('asistentesnomusicos', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // Eliminar registros en la tabla 3
                    await deleteRecordsFromTable('reverseservicios', 'sesiongrabacion_id='+sesiongrabacion_id);

                    await deleteRecordsFromTable('reverseserviciosadicionales', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    await deleteRecordsFromTable('bitacora', 'sesiongrabacion_id='+sesiongrabacion_id);

                    await deleteRecordsFromTable('equipoestudio', 'sesiongrabacion_id='+sesiongrabacion_id);
                
                    // ... Agregar más tablas si es necesario
                
                    await connection.commit();
                    console.log('Registros eliminados exitosamente');

                    resolve({
                        codigo: 0
                    })
                
                  } catch (error) {
                    await connection.rollback();
                    console.error('Error eliminando registros:', error);
                
                  } finally {
                    //db.end();
                  }

            }    
        });
    });
   });
  }


  changereServationStatus= async (idsesiongrabacion) => {

    return new Promise((resolve, reject) => {
  
        const query = 'UPDATE sesiongrabacion SET estatus_id = 1 WHERE idsesiongrabacion = ?';
    
        mysqlConnection.query(query, [ idsesiongrabacion], function (err,rows, result) {   
            if(!err){
               
                resolve({
                  codigo: 0
                })
            }else{
              
                console.log(err)
                reject(err)
            }
        })
    })
}

listar= (userId,status) => {

    return new Promise((resolve, reject) => {
        const query = "select * from cita.sesiongrabacion where userId="+userId+ " and estatus_id="+status+" order by dias desc;";
        mysqlConnection.query(query, (err, rows, fields) => {        
            if(!err){
               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


historyUser = (userId,page) => {

    var numPerPage = 10;
    var skip = (page - 1) * numPerPage;
    var limit = skip + ',' + numPerPage;
  
    //let userId=data.userId;
  
    return new Promise((resolve, reject) => {
       
  
    mysqlConnection.query("SELECT count(*) as numRows FROM sesiongrabacion where userId = " + userId , async function (err, rows, fields) {
  
      if (err) {
        const responseError = {
          code: -1,
          mensaje: err.sqlMessage,
          result: err
  
        };
        resolve(responseError)
      } else {
        var numRows = rows[0].numRows;
        var numPages = Math.ceil(numRows / numPerPage);
  
        const sql01 = "select *  from sesiongrabacion  where userId=" + userId + " order by  dias desc LIMIT  " + limit;
  
       
        mysqlConnection.query(sql01, function (err, rows, fields) {
          if (err) {
            const responseError = {
              code: -1,
              mensaje: err.sqlMessage,
              result: err
  
            };
            resolve(responseError)
          } else {
  
  
            const response = {
              code: 0,
              mensaje: "Operacion Existoso",
              page: page,
              numPages: numPages,
              lista: rows
            };
            resolve(response)
  
          }
        });
      }
    });
  
  
    })
  
  }


  historyAdmin = (page) => {

    var numPerPage = 10;
    var skip = (page - 1) * numPerPage;
    var limit = skip + ',' + numPerPage;
  
    //let userId=data.userId;
  
    return new Promise((resolve, reject) => {

  
    mysqlConnection.query("SELECT count(*) as numRows FROM sesiongrabacion where estatus_id =3 " , async function (err, rows, fields) {
  
      if (err) {
        const responseError = {
          code: -1,
          mensaje: err.sqlMessage,
          result: err
  
        };
        resolve(responseError)
      } else {
        var numRows = rows[0].numRows;
        var numPages = Math.ceil(numRows / numPerPage);
  
        const sql01 = "select *  from sesiongrabacion  where  estatus_id =3  order by  dias desc LIMIT  " + limit;
  
       
        mysqlConnection.query(sql01, function (err, rows, fields) {
          if (err) {
            const responseError = {
              code: -1,
              mensaje: err.sqlMessage,
              result: err
  
            };
            resolve(responseError)
          } else {
  
  
            const response = {
              code: 0,
              mensaje: "Operacion Existoso",
              page: page,
              numPages: numPages,
              lista: rows
            };
            resolve(response)
  
          }
        });
      }
    });
  
  
    })
  
  }


  function runParallelQueries(queries) {
    return new Promise((resolve, reject) => {
      mysqlConnection.getConnection((err, connection) => {
        if (err) {
          reject(err);
          return;
        }
  
        const results = [];
  
        // Iterar sobre las consultas y ejecutarlas en paralelo
        queries.forEach((query, index) => {
          connection.query(query, (error, result) => {
            if (error) {
              reject(error);
              return;
            }
  
            results[index] = result;
  
            // Verificar si todas las consultas se han completado
            if (results.filter(Boolean).length === queries.length) {
              connection.release(); // Liberar la conexión del pool
              resolve(results);
            }
          });
        });
      });
    });
  }
  
  detailReserve= (sesiongrabacion_id) => {

    return new Promise((resolve, reject) => {
      const queries = [
        'SELECT * FROM sesiongrabacion where idsesiongrabacion='+sesiongrabacion_id,
        'SELECT * FROM asistentesmusicos where sesiongrabacion_id='+sesiongrabacion_id,
        'SELECT * FROM asistentesnomusicos where sesiongrabacion_id='+sesiongrabacion_id,
        'SELECT s.id,s.nombreServicio,s.costoHora FROM servicios s, reverseservicios r where s.id=r.servicio_id and r.sesiongrabacion_id='+sesiongrabacion_id,
        'SELECT s.id,s.nombreServicio,s.costoHora FROM serviciosadicionales s, reverseserviciosadicionales r where s.id=r.servicioadiconales_id and r.sesiongrabacion_id='+sesiongrabacion_id,
        'SELECT * FROM bitacora where sesiongrabacion_id='+sesiongrabacion_id,
        'SELECT * FROM equipoestudio where sesiongrabacion_id='+sesiongrabacion_id,
        
      ];
      
      runParallelQueries(queries)
        .then((results) => {
  
        let respuesta={
          reserva:results[0],
          asistentesmusicos:results[1],
          asistentesnomusicos:results[2],
          servicios:results[3],
          serviciosAdicional:results[4],
          bitacora:results[5],
          equipoestudio:results[6],
        }
  
          resolve(respuesta)
        })
        .catch((error) => {
          console.error('Error al ejecutar las consultas:', error);
        });
    })
  }
  
  

  module.exports = {
    createCita,
  
    validarReserve,
    reverseService,
    reverseServiceAdditional,
    registrarAsistentesMusicos,
    registrarAsistentesNoMusicos,
    deleteFromMultipleTables,
    changereServationStatus,
    registrarEquipoEstudio,
    registrarBitacora,
    deleteFromMultipleTablesAdmin,
    deleteFromMultipleTablesAdminBitacora,
    updatePriceCita,
    confirmReserve,
    finalizarReserve,
    listar,
    historyUser,
    historyAdmin,
    detailReserve,
    deleteFromMultipleTablesReserve
  }