const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');


 
  listar= (status) => {

    return new Promise((resolve, reject) => {
        const query = "select * from cita.sesiongrabacion where estatus_id="+status+" order by dias desc;";
        mysqlConnection.query(query, (err, rows, fields) => {        
            if(!err){
               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


function runParallelQueries(queries) {
  return new Promise((resolve, reject) => {
    mysqlConnection.getConnection((err, connection) => {
      if (err) {
        reject(err);
        return;
      }

      const results = [];

      // Iterar sobre las consultas y ejecutarlas en paralelo
      queries.forEach((query, index) => {
        connection.query(query, (error, result) => {
          if (error) {
            reject(error);
            return;
          }

          results[index] = result;

          // Verificar si todas las consultas se han completado
          if (results.filter(Boolean).length === queries.length) {
            connection.release(); // Liberar la conexión del pool
            resolve(results);
          }
        });
      });
    });
  });
}



detailReserve= (sesiongrabacion_id) => {

  return new Promise((resolve, reject) => {
    const queries = [
      'SELECT * FROM sesiongrabacion where idsesiongrabacion='+sesiongrabacion_id,
      'SELECT * FROM asistentesmusicos where sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT * FROM asistentesnomusicos where sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT s.id,s.nombreServicio,s.costoHora FROM servicios s, reverseservicios r where s.id=r.servicio_id and r.sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT s.id,s.nombreServicio,s.costoHora FROM serviciosadicionales s, reverseserviciosadicionales r where s.id=r.servicioadiconales_id and r.sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT * FROM bitacora where sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT * FROM equipoestudio where sesiongrabacion_id='+sesiongrabacion_id,
      
    ];
    
    runParallelQueries(queries)
      .then((results) => {
  

      let respuesta={
        reserva:results[0],
        asistentesmusicos:results[1],
        asistentesnomusicos:results[2],
        servicios:results[3],
        serviciosAdicional:results[4],
        bitacora:results[5],
        equipoestudio:results[6],
      }

        resolve(respuesta)
      })
      .catch((error) => {
        console.error('Error al ejecutar las consultas:', error);
      });
  })
}

listServicePrice= (sesiongrabacion_id) => {

  return new Promise((resolve, reject) => {
    const queries = [
     
      'SELECT r.id,s.nombreServicio,s.costoHora FROM servicios s, reverseservicios r where s.id=r.servicio_id and r.sesiongrabacion_id='+sesiongrabacion_id,
      'SELECT r.id,s.nombreServicio,s.costoHora FROM serviciosadicionales s, reverseserviciosadicionales r where s.id=r.servicioadiconales_id and r.sesiongrabacion_id='+sesiongrabacion_id,
      
    ];
    
    runParallelQueries(queries)
      .then((results) => {

      let respuesta={
        servicios:results[0],
        serviciosAdicional:results[1]
      
      }

        resolve(respuesta)
      })
      .catch((error) => {
        console.error('Error al ejecutar las consultas:', error);
      });
  })
}

  module.exports = {
    listar,
    detailReserve,
    listServicePrice
  }