const mysqlConnection = require('../config/database');


getBitacoraRecords = (sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `
        
         SELECT bitacora.id,
         DATE_FORMAT(fecha, '%d/%m/%Y %h:%i %p')  AS fecha,
        informe,
        users.name
        from bitacora
        left join users
        on bitacora.user_id = users.id
        where sesiongrabacion_id = ?
        order by bitacora.id desc
        `;
        mysqlConnection.query(queryPlaca,[sesiongrabacion_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

insertBitacora = (informe, sesiongrabacion_id, user_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `insert into bitacora (fecha, informe, sesiongrabacion_id, user_id) values(NOW(), ?, ?, ?);`;
        mysqlConnection.query(queryPlaca,[informe, sesiongrabacion_id, user_id], (error, results) => { 
            if(!error){               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
}


module.exports = {
    insertBitacora,
    getBitacoraRecords
}