const { Router } = require('express');
const router = Router();
const controller = require('../controllers/post.api.controller');
const auth = require('../auth');
///Auth-------------------------------------


router.post('/signup', controller.signup);
router.post('/addDatetime', controller.addDatetime);
router.post('/newMusico', controller.newMusico);
router.post('/updateMusico', controller.updateMusico);
router.post('/updateCitaData', controller.updateCitaData);
router.post('/newNoMusico', controller.newNoMusico);
router.post('/addService/:servicio_id/:sesiongrabacion_id', controller.addService); 
router.post('/addAditionalService/:session_id', auth.isAuthenticated, controller.addAditionalService); 
router.post('/addEquipoestudio', controller.addEquipoestudio); 
router.post('/loginpost/:method?/:id?', controller.loginPost); 
router.post('/signupAdmin', controller.signupAdmin); 
router.post('/cotizacionPost/:idsesiongrabacion/:idCotizacion?', controller.cotizacionPost); 

router.post('/sendQuotePost/:idsesiongrabacion/:cotizacionId', controller.sendQuotePost); 
router.post('/passwordResetPost', controller.passwordResetPost); 
router.post('/passwordResetFormPost', controller.passwordResetFormPost);
router.post('/newAdminPost', controller.newAdmin); 
router.post('/updateAdminPost/:id', controller.updateAdminPost); 
router.post('/bitacoraPost/:idsesiongrabacion',auth.isAuthenticated, controller.bitacoraPost); 
router.post('/unsubscribePost', controller.unsubscribePost); 
router.post('/addHorasYFechasPost', auth.isAuthenticated,  controller.addHorasYFechasPost); 
router.post('/updateHorasYFechasPost', auth.isAuthenticated, controller.updateHorasYFechasPost); 
router.post('/newServicePost', auth.isAuthenticated, controller.newServicePost); 
router.post('/updateServicePost/:id', controller.updateServicePost); 
router.post('/pricesPost/:id', auth.isAuthenticated, controller.pricesPost); 
router.post('/upadateAditionalService', auth.isAuthenticated, controller.upadateAditionalService); 
router.post('/addPercentageToCotizaciones', auth.isAuthenticated, controller.addPercentageToCotizaciones); 
router.post('/addPercentageIndiv', auth.isAuthenticated, controller.addPercentageIndiv); 
router.post('/addReceivedPayment', auth.isAuthenticated, controller.addReceivedPayment); 




module.exports = router;