const { Router } = require('express');
const router = Router();
const controller = require('../controllers/update.api.controller');

const auth = require('../auth');
///Auth-------------------------------------
router.put('/updateNoMusico', controller.updateNoMusico);
router.put('/updateEquipoEstudio', controller.updateEquipoEstudio);
router.post('/editEleccionPost/:id', auth.isAuthenticated , controller.editEleccionPost)
router.put('/updatePercentageIndiv', auth.isAuthenticated , controller.updatePercentageIndiv)
router.put('/updateReceivedPaymentById', auth.isAuthenticated , controller.updateReceivedPaymentById)


module.exports = router;