const connection = require('../config/database');

module.exports = {
  query: (sql, params) => {
    return new Promise((resolve, reject) => {
      connection.query(sql, params, (err, rows) => {
        if (err) {
          reject(err);
        } else {
          resolve(rows);
        }
      });
    });
  },
};
