const nodemailer = require('nodemailer');
const path = require('path');
const ejs = require('ejs');
const {  EMAILUSER, MAINURL, CURRENTSUBDOMAIN, EMAILHOST, EMAILPORT, EMAILPASS } = require('../config');

const AWS = require('aws-sdk');

const user = EMAILUSER;


const EMAIL_SETTINGS = {
    host:  EMAILHOST,    
    secure: true,               
    port: EMAILPORT,        
    auth: {
      user: user,
      pass: EMAILPASS
    }
}



const SES_CONFIG = {
    accessKeyId: '',
    secretAccessKey: '',
    region: ''
};
AWS.config.update(SES_CONFIG)
const AWS_SES = new AWS.SES({apiVersion: '2010-12-01'});





const sendCotizacion = async(userName, email, urlToAccept) => {
    try {
        
      const html = await ejs.renderFile(path.join(__dirname, `/cotizacion.ejs`), 
      {
          name: userName, 
          mainUrl: MAINURL,
          unsubscribeUrl: `${MAINURL}/unsubscribe`,
          noticeOfPrivacyUrl: `${MAINURL}/avisodeprivacidad`,
          urlAccept: `${MAINURL}${urlToAccept}`
          }, 
          {async:true}
      );
      let params = {
        Source: 'noreply@bunkerstudios.mx',
        Destination: {
          ToAddresses: [
            email
          ],
        },
        ReplyToAddresses: [],
        Message: {
          Body: {
            Html: {
              Charset: 'UTF-8',
              Data: html,
            },
          },
          Subject: {
            Charset: 'UTF-8',
            Data: "Cotización - Bunker studios",
          }
        },
      };
      return AWS_SES.sendEmail(params).promise();
      return { result: true }
    } catch (error) {
      return { result: false, emailsList, error  }
    }
     
  }





const test = async (recipientEmail, name) => {
    let params = {
        Source: 'noreply@bunkerstudios.mx',
        Destination: {
          ToAddresses: [
            recipientEmail
          ],
        },
        ReplyToAddresses: [],
        Message: {
          Body: {
            Html: {
              Charset: 'UTF-8',
              Data: 'This is the body of my email!',
            },
          },
          Subject: {
            Charset: 'UTF-8',
            Data: `Hello, ${name}!`,
          }
        },
      };
      return AWS_SES.sendEmail(params).promise();
}

module.exports = { test, sendCotizacion }