/*!
* Start Bootstrap - Clean Blog v6.0.9 (https://startbootstrap.com/theme/clean-blog)
* Copyright 2013-2023 Start Bootstrap
* Licensed under MIT (https://github.com/StartBootstrap/startbootstrap-clean-blog/blob/master/LICENSE)
*/
window.addEventListener('DOMContentLoaded', () => {
    let scrollPos = 0;
    const mainNav = document.getElementById('mainNav');
    const headerHeight = mainNav.clientHeight;
    window.addEventListener('scroll', function() {
        const currentTop = document.body.getBoundingClientRect().top * -1;
        if ( currentTop < scrollPos) {
            // Scrolling Up
            if (currentTop > 0 && mainNav.classList.contains('is-fixed')) {
                mainNav.classList.add('is-visible');
            } else {                
                mainNav.classList.remove('is-visible', 'is-fixed');
            }
        } else {
            // Scrolling Down
            mainNav.classList.remove(['is-visible']);
            if (currentTop > headerHeight && !mainNav.classList.contains('is-fixed')) {
                mainNav.classList.add('is-fixed');
            }
        }
        scrollPos = currentTop;
    });
})
function getValueFromDropDownById(id) {
    var valueSelected = 0;
    var element = document.getElementById(id);
    if (element != undefined) {
        if(element.options[element.selectedIndex] == undefined)
        {
            return 0;
        }
        else
        {
            valueSelected = element.options[element.selectedIndex].value;    
        }        
    }
    return valueSelected;
}

function highlightField(fieldId, text, color)
{
    let element = document.getElementById(fieldId)
    element.innerText = text;
    element.style.color = color;
}
function clearField(fieldId)
{
    let element = document.getElementById(fieldId)
    element.innerText = "";
    element.style.color = "";
}
function input_text_Validation(input)
{
  if(input.value != undefined && input.value != null && input.value.length > 0)
  {
    return true;
  }
  else
  {
    return false;
  }
}