const { Router } = require('express');
const router = Router();
const controller = require('../controllers/delete.api.controller');
const auth = require('../auth');


router.delete('/deleteFechaAndHorarios/:id', controller.deleteFechaAndHorarios);
router.delete('/deleteAsistenteMusico/:id', controller.deleteAsistenteMusico);
router.delete('/deleteAsistenteNoMusico/:id', controller.deleteAsistenteNoMusico);
router.delete('/deleteServicio/:id/:sesionId', controller.deleteServicio);
router.delete('/deleteServicioAdicional/:id/:sesionId', controller.deleteServicioAdicional);
router.delete('/deleteEquipoestudio/:id', controller.deleteEquipoestudio);
router.delete('/deleteSesionDeGrabacion/:idsesiongrabacion', controller.deleteSesionDeGrabacion);
router.delete('/deleteAditionalService/:id/:idsesiongrabacion',auth.isAuthenticated, controller.deleteAditionalService);
router.delete('/deletePercentageById/:id', controller.deletePercentageById);
router.delete('/deleteReceivedPaymentById/:id', controller.deleteReceivedPaymentById);


module.exports = router;